<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();


if (!isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or 
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;
$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}


function getSpecificGlobalSettings($conn_rjllearning_specific,$institution_id,$branch_id) {
    
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM  institution_global_settings where institution_id =? AND branch_id  = ? ");
    $sql->execute(array($institution_id,$branch_id));
    $rows = $sql->fetchAll();
    $array_return = [];
    // print_r($rows);die();
    if (count($rows) >= 1) {
            
        $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows[0]['branch_id']);
        $faculty_attendance_setting = json_decode($rows[0]['faculty_attendance_setting'], true);
        $accounting_setting = json_decode($rows[0]['accounting_setting'], true);
         $birthday_setting = json_decode($rows[0]['other'], true);
         $array_return[]  = array('setting_id'=> $rows[0]['id'],'institution_id'=> $rows[0]['institution_id'],'branch_id'=> $branch_info,'attendance_system'=> $rows[0]['attendance_system'],
         'faculty_attendance_setting' => $faculty_attendance_setting,'birthday_setting'=>$birthday_setting,'accounting_setting' => $accounting_setting,'fee_concession_application'=>$rows[0]['fee_concession_application']);
      
    }else{
          errorreturn("Invalid global settings.");
    }
    return  $array_return;

}

if($postdata['function_type']  == "fetch_attendance_setting") {  
    
    $success['data'] = getSpecificGlobalSettings($conn_rjllearning_specific,$institution_id,$branch_id);
    successreturn($success);
      
}

